/**

       ϰ ޼ ͸ DB  ϴ 
  ƾ  ִ.

    ޼ ũ д    ũ ׼  ⿡
  óϴ  ؾѴ.

  ⺻ ͺ̽ MySQL ̴. PostgreSQL ̳ ٸ DB    
   ⸸  ϸ ǵ Ѵ.
@todo
	- ޼  ,  ʵ带 mysql_real_escape_string()  escape ų .
		--   MySQL documentation    ϴ    .

*/

#include "_database.h"
#include "_parse.h"
#include "_errdbg.h"
#include "MySQLib.h"
#include <stdio.h>
#include <time.h>


#include <string>
using namespace std;


MySQLib _my;

/**
@return
	On Success, true.
	Otherwise, false.
*/


bool _db_connect()
{
	
	_my.DebugPrint( true );

	if ( ! _my.Connect(
		(char *) DATABASE_HOST,
		(char *) DATABASE_USER,
		(char *) DATABASE_PASS,
		(char *) DATABASE_NAME,
		(unsigned int) DATABASE_PORT)
		)
	{
		return false;
	}

	return true;
}

bool _db_close()
{
	return _my.Close();
}


/**
	 ּҸ Է ޾Ƽ, account, domain  и  ,
	DB  Ͽ  UI  Ѵ.
@param	const char *mail
	 ּ
	    ޼ "To:" ʵ忡 ִ  ּҿѴ.
	  ּҸ   ޴   ϰ ȴ.
@param	bIDX=false
	  true ̸ Է  mail  'ڹȣ'  .
	,  ȣ    ˾Ƴ  
	  true  ϸȴ.

@return
	, 0
	 ̵ , 1
@todo
	 ̵  , ó
	⼭ ui->fk_table    ־  ,
	ƴϸ, ޼  ,  ̺   ؾѴ.
*/

int _db_get_account_infomation( const char *mail, UI *ui, bool bIDX )
{

	bool retvar;
	string _q("SELECT idx, fk_table, quota_max, quota_curr FROM account WHERE");

	if ( bIDX ) {
		retvar = _my.Query("%s idx=%s", _q.c_str(), mail );
	}
	else {		
		char account[256], domain[256];
		_get_idomain( mail, account, domain );
		retvar = _my.Query("%s account='%s' AND domain='%s'", _q.c_str(), account, domain);
	}
	
	if ( ! retvar ) {
		_error_fatal( "db query error" );
	}

	if ( _my.NextRow() == MYSQL_EOF ) 
		return 1;

	ui->idx			= atoi( _my.Field( 0 ) );
	ui->fk_table	= atoi( _my.Field( 1 ) );
	ui->quota_curr	= atoi( _my.Field( 2 ) );
	ui->quota_max	= atoi( _my.Field( 3 ) );

	return 0;
}




/**
	Ľ̵ ϵ͸ ͺ̽ Ѵ.
@param	int idx
	 ȣ ´.
	  0 ̸  ȣ  ̹Ƿ fk_table  nouser  ȴ.
*/
int _db_insert_message
( int idx, int fk_table, const char *_to, const char *_from, const char *_sender,
 const char *_reply_to, const char *_date, const char *_return_path,
 const char *_subject, const char *_content_type, const char *_charset,
 const char *_x_priority, const char *_d_n_t,
 const char *header, const char *body)
{
	bool	retvar;
	char	*pEsc = NULL;
	char	_char16[16];
	int		size = 0 , stamp = 0;
	string _q;
	

	_q = "INSERT INTO mbox_";
	if ( idx ) {
		sprintf( _char16, "%d", fk_table );
		_q += _char16;
	}
	else {
		/**
		@todo 2002/09/07
			mbox_nouser ̺   Ǵ üũ
		*/
		_q += "nouser";
	}


	_q += " ( fk_user, fk_box, _to, _from, _sender, _reply_to, _date, _return_path, _subject, _content_type, _charset, _x_priority, size, stamp, _d_n_t, header, body) ";
	_q += " VALUES (";

	sprintf( _char16, "%d", idx );
	_q += _char16; _q += ",";
	_q += " 0, ";			_q += "'";
	_q += _to;				_q += "','";
	_q += _from;			_q += "','";
	if ( _sender )			_q += _sender;					_q += "','";
	if ( _reply_to )		_q += _reply_to;				_q += "','";
	if ( _date )			_q += _date;					_q += "','";
	if ( _return_path )		_q += _return_path;				_q += "','";
	if ( _subject )			_q += _subject;					_q += "','";
	if ( _content_type )	_q += _content_type;			_q += "','";
	if ( _charset )			_q += _charset;					_q += "','";
	if ( _x_priority )		_q += _x_priority;				_q += "','";
	// ߸ ̴.
	//  ƴ,  ü ũⰡ ǾѴ.,  Է   ֵ 
	if ( body ) {
		pEsc = _my.Escape( body );
		size = strlen( pEsc );		
	}



	stamp = (int) time(0);

	_q += size;		_q += "','";
	_q += stamp;		_q += "','";

	if ( _d_n_t )		_q += _d_n_t;					_q += "','";
	if ( header )		_q += header;					_q += "','";
	if ( pEsc )			_q += pEsc;						_q += "'";
	if ( pEsc )			delete[] pEsc;

	_q += " )";

	retvar = _my.LongQuery( _q.c_str() );
	if ( ! retvar ) {
		_error_fatal( "error while inserting message" );
	}




	printf("%s", _q.c_str() );

	return 0;
}




