/**
	 ̺귯 RFC822  Ϻϰ ȭس ϰ ִ.
	 ⼺ ...
@note
	RFC822   Ǵ ޼   ȭ ϰ ִ.
	RFC822  ǥ̰ ǥ ޼   ִٸ   ذ  ̴.
*/

#include <string.h>
#include "_parse.h"


/**

	in  ִ ڿ ϳ ū out  ִ´.
@return
	in  ϳ ū    ġ   
	ڿ   NULL  

	in  ִ ڿ ϳ ū out  ִ´.
	*type  ū Ÿ ִ´.
@note
	Ȱ .
@note
	- ū иڴ RFC  Ͱ ٸ.
	- ū ִ ̴   ʴ.
		out    in    buffer overflow   ɼ ִ.
		

	- ū " ;,=\t\r\n<>  ̵ȴ.
	-- ֵǥ ѷ ׿ ڿ ϳ ū̴.
		 ο ִ  (Ư, ū, Ÿ) ڴ õȴ.
		̽ٵ ڸ óѴ.
		ū Ÿ : _T_QUOTE

	-- Ȭǥ("'"  "'") ׿ ڿ ֵǥ  ޵ȴ.
	--  ȣ("<"  ">") ׿ ڿ ֵǥ  ޵ȴ.

*/

char *_token( char *out, char *in, int *type )
{
	char ch;
	*out	= '\0';

	while ( ch = *in++ )
	{
		switch ( ch ) {
		case 0 :
			return 0;
		case '"' :
			while (*in) {
				ch = *in++;
				if (ch == '"') break;
				if (ch == '\\') if (*in) ch = *in++;
				*out++ = ch;
			}
			*out	= '\0';
			*type	= _T_QUOTE;
			return in;
		case '\'' :
			while (*in) {
				ch = *in++;
				if (ch == '\'') break;
				if (ch == '\\') if (*in) ch = *in++;
				*out++ = ch;
			}
			*out	= '\0';
			*type	= _T_QUOTE2;
			return in;
		case '<' :
			while (*in) {
				ch = *in++;
				if (ch == '>') break;
				if (ch == '\\') if (*in) ch = *in++;
				*out++ = ch;
			}
			*out	= '\0';
			*type	= _T_ANGLE;
			return in;
		case ' ' : *out	= '\0'; *type	= _T_SPACE; return in;
		case ',' : *out	= '\0'; *type	= _T_COMMA; return in;
		case '\r' : *out	= '\0'; *type	= _T_CR; return in;
		case '\n' : *out	= '\0'; *type	= _T_LF; return in;

		default :
			*out ++ = ch;
			break;

		} // eo switch

	} // eo while

	*out = '\0';
	*type = _T_END;
	return 0;
}




/**
	mail   ּ   ִ ˻Ѵ.
@note
	mail ڿ a-zA-z0-9  -_@.     ,
	@   ó Ÿ ȵǸ, @ Ŀ ϳ ̻ .  ־ Ѵ.
	@  ݵ ϳ ŸѴ.
	abc@[211.193.134.123]    ּҴ  ȵȴ.
@example

  Ʒ  str ڿ ִ  ּҸ  ϴ ڵ̴.
	char *str = "my.mule@yellow.com whyblank@not.does how@now, \"mymail@sun.co.kr\" mark28@gohosting.co.kr, markgr@kimhaenet.com, \"ǥ\" <kangik60@lycos.co.kr>,\"Mark, \r\nGr\" <mark@gohosting.co.kr>, 'MyName, And Your Name' <come@finally.com>, \"good, \" go@go.com, your name <yourname@yourdom.com>, webmater@gohostig.co.kr, \"ũ\" mark@kimhaenet.co.kr,'Mark, Jh' <mark@gohosting.co.kr>, 'For MS' <forms@kimhaenet.co.kr>,\"What, a\"<abc@dot.com>, gogo@gogo.com,,,mark@goho laster ";
	//str = "\"mymail@sun.co.kr\" mark28@gohosting.co.kr, m";
	char *str2 = str;
	int type;
	char *ptr;
	while ( str2 ) {
		ptr = _get_memory( strlen( str2 ) );
		str2 = _token( ptr, str2, &type );
		if ( _check_mail( ptr ) ) {
		// ū иڰ  ȣ ̰ų ޸    ּҷ  Ѵ.
		// ǥ ѷ ׿  뿡 
			if ( type == _T_ANGLE || type == _T_COMMA ) {
				printf("%c,%s\n", type,ptr);
			}
		}
		_free_memory( ptr );
	}
	_check_memory();
*/
bool _check_mail( const char *mail )
{
	
	int pAt=0, pDot=0;
	char ch;
	for ( int k = 0; *(mail + k); k++ ) {
		ch = *( mail + k );
		if ( 
			( ch >= 'a' && ch <= 'z' )
			|| ( ch >= 'A' && ch <= 'Z' )
			|| ( ch >= '0' && ch <= '9' )
			|| ch == '-' || ch == '_' || ch == '@' || ch == '.'
			) {
			if ( ch == '@' ) {
				if ( ! pAt ) pAt = k;
				else return false;
			}
			else if ( ch == '.' ) {
				if ( ! pAt ) return false;
				else pDot = k;
			}
		}
		else
			return false;
	} // eo for
	
	if ( pAt >= pDot ) return false;
	return true;
}






















/**
	 ּҸ  ִ ڿ Է ޾Ƽ  ּҸ Ѵ.

@param	char *buffer
	 ּҸ  ڿ
	   ־Ѵ.

@param	const char *mail
	 ּҸ  ִ ڿ
@note
	 ּ   ̴.
		account@domain.com
		<account@domain.com>
		"̸" <account@domain.com>
		̸ <account@domain.com>
	Ǵ Ʒ  ϳ ڿ   ּҰ ׷   ִ.
	"Mark, Gr" <mark@gohosting.co.kr>, 'MyName, And Your Name' <come@finally.com>, "good, " go@go.com, your name <yourname@yourdom.com>, webmater@gohostig.co.kr, "ũ" mark@kimhaenet.co.kr,'Mark, Jh' <mark@gohosting.co.kr>, 'For MS' <forms@kimhaenet.co.kr>,"What, a"<abc@dot.com>, gogo@gogo.com

	 Լ ׷   ּҴ ó  ʰ,
	 ϳ  ּҸ  ִ ڿ
	 ּҸ buffer  ´.
	,  ּҰ     ó ϳ Ѵ.
@return
	 ּҸ   NULL  .
	Ͽ, *buffer  ùٸ  ּҸ ־ Ѵ.

*/
char *_get_mail_address( char *buffer, const char *mail)
{


	int type;
	char *str = (char *)mail;
	
	while ( str ) {
		
		str = _token( buffer, str, &type );
		if ( _check_mail( buffer ) ) {
		// ū иڰ  ȣ ̰ų ޸    ּҷ  Ѵ.
		// ǥ ѷ ׿  뿡 
			if ( type == _T_ANGLE || type == _T_COMMA ) {
				return buffer;
			}
		}
	}
	return NULL;
}



/**
@param	const char *mail
	mail address
@param	char *account
	a memory pointer to get the account from the mail address
@param	char *domain
	a memory pointer to get the domain from the mail address
@return
	On success, true
	Otherwise, false
*/


bool _get_idomain( const char *mail, char *account, char *domain )
{
	
	if ( ! _check_mail( mail ) )
		return false;	// bad mail

	if ( strlen(mail) > 255 )
		return false;	// too long
	
	while ( *mail && *mail != '@' ) *account++ = *mail ++;
	*account = '\0';
	mail ++;

	while ( *mail ) *domain++ = *mail ++;
	*domain = '\0';


	return true;
}
