
#ifndef __PARSE_H_
#define __PARSE_H_


#define _T_UNKNOWN		-1
#define _T_END			0
#define _T_QUOTE		'"'
#define _T_QUOTE2		'\''
#define _T_SPACE		' '
#define _T_ANGLE		'<'
#define _T_COMMA		','
#define _T_CR			'\r'
#define _T_LF			'\n'


char *_token( char *out, char *in, int *type );
bool _check_mail( const char *mail );
char *_get_mail_address( char *buffer, const char *mail);
bool _get_idomain( const char *mail, char *account, char *domain );



#endif
