-- MySQL dump 8.22
--
-- Host: localhost    Database: mywebmail
---------------------------------------------------------
-- Server version	3.23.52

--
-- Table structure for table 'account'
--

CREATE TABLE account (
  idx int(10) unsigned NOT NULL auto_increment,
  account char(16) NOT NULL default '',
  domain char(16) NOT NULL default '',
  password char(32) NOT NULL default '',
  status enum('disable','enable','delay') NOT NULL default 'disable',
  fk_table mediumint(8) unsigned NOT NULL default '0',
  quota_max int(10) unsigned NOT NULL default '0',
  quota_curr int(10) unsigned NOT NULL default '0',
  PRIMARY KEY  (idx),
  UNIQUE KEY mail (account,domain)
) TYPE=MyISAM COMMENT='mail  ';

--
-- Table structure for table 'box'
--

CREATE TABLE box (
  idx int(10) unsigned NOT NULL auto_increment,
  fk_user int(10) unsigned NOT NULL default '0',
  name char(32) NOT NULL default '',
  comment char(64) NOT NULL default '',
  PRIMARY KEY  (idx),
  KEY fk_user (fk_user)
) TYPE=MyISAM COMMENT=' 缭  ̺';

--
-- Table structure for table 'file'
--

CREATE TABLE file (
  idx int(10) unsigned NOT NULL auto_increment,
  PRIMARY KEY  (idx)
) TYPE=MyISAM;

--
-- Table structure for table 'mbox_1'
--

CREATE TABLE mbox_1 (
  idx int(10) unsigned NOT NULL auto_increment,
  fk_user int(10) unsigned NOT NULL default '0',
  fk_box mediumint(8) unsigned NOT NULL default '0',
  _to varchar(255) NOT NULL default '',
  _from varchar(255) NOT NULL default '',
  _sender varchar(255) NOT NULL default '',
  _reply_to varchar(255) NOT NULL default '',
  _date varchar(255) NOT NULL default '',
  _return_path varchar(255) NOT NULL default '',
  _subject varchar(255) NOT NULL default '',
  _content_type varchar(255) NOT NULL default '',
  _charset varchar(255) NOT NULL default '',
  _x_priority varchar(255) NOT NULL default '',
  size int(10) unsigned NOT NULL default '0',
  stamp int(10) unsigned NOT NULL default '0',
  _status enum('new','open','replay','forward','replyall','pop3','sent','delete') NOT NULL default 'new',
  _d_n_t varchar(255) NOT NULL default '',
  header text NOT NULL,
  body text NOT NULL,
  PRIMARY KEY  (idx),
  KEY fk_user (fk_user,fk_box)
) TYPE=MyISAM;

--
-- Table structure for table 'mbox_nouser'
--

CREATE TABLE mbox_nouser (
  idx int(10) unsigned NOT NULL auto_increment,
  fk_user int(10) unsigned NOT NULL default '0',
  fk_box mediumint(8) unsigned NOT NULL default '0',
  _to varchar(255) NOT NULL default '',
  _from varchar(255) NOT NULL default '',
  _sender varchar(255) NOT NULL default '',
  _reply_to varchar(255) NOT NULL default '',
  _date varchar(255) NOT NULL default '',
  _return_path varchar(255) NOT NULL default '',
  _subject varchar(255) NOT NULL default '',
  _content_type varchar(255) NOT NULL default '',
  _charset varchar(255) NOT NULL default '',
  _x_priority varchar(255) NOT NULL default '',
  size int(10) unsigned NOT NULL default '0',
  stamp int(10) unsigned NOT NULL default '0',
  _status enum('new','open','replay','forward','replyall','pop3','sent','delete') NOT NULL default 'new',
  _d_n_t varchar(255) NOT NULL default '',
  header text NOT NULL,
  body text NOT NULL,
  PRIMARY KEY  (idx),
  KEY fk_user (fk_user,fk_box)
) TYPE=MyISAM;

