#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <stdarg.h>


void _error_fatal(char *format, ...)
{
	char message[1024];
	int status;
	va_list arglist;

	va_start(arglist, format);
	status = vsprintf(message, format, arglist);
	if(strlen(message) + 1 > sizeof(message) || status == EOF)
		printf("The message is too long or invalid.");
	va_end(arglist);

	printf("\a\a");
	printf(message);
	exit(1);
}
