/**
	MTA  sendmail   óϴ ƾ̴.
@note

	/var/queue/mail/mark   ޼()  ִ  Ͽ,
	޼  Ľ Ѵ.
@todo
	- To:   ,   default_user  To:  Ѵ.
		,    ޾   ־ϸ,
		MailDecoder::SetDefualtHeaderTo() Լ  ⺻ To:   Ѱ   ־Ѵ.
	- 켱  Ͽ ⺻  ּҰ Ƿ mbox_nouser ̺ Ѵ.
*/

#include "_file.h"
#include "_library.h"
#include "_memory.h"
#include "_parse.h"
#include "_errdbg.h"
#include "_qfetch.h"
#include "_qfetch_sendmail.h"



char _message_line[MAXBUF_MAILLINE];



/**
	

@process
	- open
	while ( all message )
	{
		- read a message
		- check the user
		- check the user's config (qouta, etc, ...)
		- parse ( mime decoding, charset decoding, bad mail check, etc, ...)
		- save message text to db, attachment to disk
	}
	- close
*/


void _qfetch_sendmail()
{
	int count_message = 0;

	MailDecoder md;
	string message;
	FILE *fr;

	printf("> _qfetch_sendmail, mailbox=%s\n", _config["mailbox"].c_str() );

	fr = _fopen( _config["mailbox"].c_str(), "r" );
	if (  fr == NULL ) {
		_error_fatal( "Sorry, but I cannot open the mailbox %s", _config["mailbox"].c_str() );
	}

	
	/** DB  */
	if ( ! _db_connect() ) {
		_error_fatal( "cannot connect to db" );
	}
	
	
	/**
		ť Ͽ ޼  
	*/
	char *ptr;
	UI ui;

	while ( _read_message( fr, message ) ) {
		count_message ++;
		md.Set( message.c_str() );
		md.Parse();

		/** ޼      */
		ptr = _get_memory( strlen(md.GetHeader( "to" )) );
		_get_mail_address( ptr, md.GetHeader( "to" ) );

		if ( _db_get_account_infomation( ptr, &ui ) ) {
			// @todo
			// ޴ ڰ   ϴ   
			// ui  Ͽ _save_message()  ϸȴ.
			// ui.idx = 0 ̸ _db_insert_message  mbox_nouser  
			// ui.status = disabled ̸ _db_insert_message  mbox_disabled  
			// ui.delay ̸ mbox_delay  
			//
			ui.idx = 0;
		}
		_free_memory( ptr );
		_save_message( md, ui );
	}
	printf("> total messages: %d\n", count_message);
	_fclose( fr );

	/** DB   */
	_db_close();


}



/**

   Լ sendmail   ڽ Ʈ  ϳ ޼ о Ѵ.

@param	FILE *fr
	޼  ִ Է Ʈ
@param	string& message
	Է Ʈ ޼ ϳ    ϱ   .
@return
	޼ о true,
	( ̻)  ޼  false
@todo
	ӵ üũ ؾѴ.
	string  ϸ    Ҵ   ߻Ѵ.
		 , ο ޸𸮸  ϰ,  ͸ ϴ ð ʿϴ.
	vector   , ޸𸮸  Ҵص    ʿ .
@todo
	ٸ MTA ʹ ȣȯ Ƿ ڵ  ̱ ؼ  ð
	ɼ óؼ ̳ʸ ڵ   ʵ ؾѴ.
	  Ų ϱ ؼ, з ó ϴ,  Լ 
	ũθ ξ óϴ ؾѴ.

*/
bool _read_message (FILE *stream, string& message) {

	message.erase( message.begin(), message.end() );


	if ( feof( stream ) ) return false;

	/**	DEPRECATED
		޼  ù  ޼ ̴.
		 ڴ ʿ  ̴. .
	*/

	//  ó ȣ   _message_line   ִ.
	// äϸ,   while   ӵ ϰ ߻Ѵ.
	if ( _message_line[0] == '\0' ) {
		if ( fgets( _message_line, MAXBUF_MAILLINE, stream ) == NULL ) return false;
	}

	//    "From "  ƴϸ ߰,
	if ( strncmp("From ", _message_line, 5) )
		message = _message_line;

	

	while ( fgets( _message_line, MAXBUF_MAILLINE, stream ) != NULL ) {
		if ( strncmp("From ", _message_line, 5) == 0 ) break;
		message += _message_line;
	}
	return true;
}
